//+------------------------------------------------------------------+
//|                                        MACDnJuiceExpert_v1.1.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""


#include <stdlib.mqh>

//---- input parameters
extern string     ExpertName                    = "=== MACDnJuiceExpert_v1.1 ===";

extern string     geInputs                      = "===== General parameters: =====";
extern int        Magic                         =  456789;     // Manual magic number
extern bool       SpreadProtection              =    true;     // Maximum spread protection
extern int        MaxSpreadPermitted            =       2;     // Value of maximum spread allowed
extern int        MaxSlippage                   =       2;     // Maximum slippage allowed
extern bool       EcnBroker                     =    true;     // Boolean to define if is ECN broker or not
extern int        NumberOfTry                   =       3;     // Number of tries to modify the orders to the broker.
extern bool       AllowMultipleTradesOnBar      =   false;     // Allow multiple operations on the same candle/bar
extern bool       AllowOnlyOneActiveTrade       =    true;     // Allow just one trade active on this pair
extern string     CustomComment                 = "MACDnJuice";// Allow customize the comment of the EA

extern string     orInputs                      = "===== Order settings: =====";
extern int        OrderMode                     =       0;     // Order Mode:0-Market,1-Limit,2-Stop,3-Limit & Stop
extern int        MaxOrders                     =       1;     // Max Number of orders
extern double     OrderDistance                 =       3;     // Distance in pips from: 
                                                               // - OrderMode = 0: Close Price  
                                                               // - OrderMode > 0: High/Low(Pending)
extern int        PendingOrderExp               =       0;     // Pending Order Expiration in bars
extern bool       OnlyBuyMode                   =    true;     // Only Buy Mode switch
extern bool       OnlySellMode                  =    true;     // Only Sell Mode switch
 
extern string     slInputs                      = "===== StopLoss settings: =====";
extern double     StopLossBUY                   =       0;     // BUY StopLoss in pips: from Order Open Price(StopLossMode=1)
extern double     StopLossSELL                  =       0;     // SELL StopLoss in pips: from Order Open Price(StopLossMode=1)
extern bool       HideStopLoss                  =   false;     // Hidden StopLoss Mode 

extern string     tpInputs                      = "===== TakeProfit settings: =====";   
extern double     TakeProfitBUY                 =       0;     // BUY Take Profit in pips
extern double     TakeProfitSELL                =       0;     // SELL Take Profit in pips
extern bool       HideTakeProfit                =   false;     // Hidden TakeProfit Mode

extern string     exInputs                      = "===== Exit settings: =====";
extern int        macdExitMode                  =       1;     // MACD Exit Mode
extern int        juiceExitMode                 =       1;     // Juice Exit Mode
extern double     MinProfit                     =   -1000;     // MinProfit in pips 

extern string     trInputs                      = "===== Trailing Stop & Breakeven settings: =====";   

extern string     trbuy                         = "-for BUY orders:";   
extern double     TrailingStopBUY               =       0;     // BUY Trailing Stop Value in pips
extern double     TrailStopStepBUY              =       0;     // BUY Trailing Stop Step in pips
extern double     BreakEvenBUY                  =       0;     // BUY Breakeven in pips  
extern double     ProfitLockBUY                 =       0;     // BUY StopLoss moves to entry price +/- ProfitLock pips after price reaches BreakEven level. 

extern string     trsell                        = "-for SELL orders:";   
extern double     TrailingStopSELL              =       0;     // SELL Trailing Stop Value in pips
extern double     TrailStopStepSELL             =       0;     // SELL Trailing Stop Step in pips
extern double     BreakEvenSELL                 =       0;     // SELL Breakeven in pips  
extern double     ProfitLockSELL                =       0;     // SELL StopLoss moves to entry price +/- ProfitLock pips after price reaches BreakEven level. 


extern string     adInputs                      = "===== Additional settings: =====";   
extern int        CommentMode                   =       1;     // Comments Mode: 0-off,1-on(use only for Live Trading and Visual Testing) 
extern int        ShowDailyProfit               =       1;
extern int        DebugMode                     =       1;     // Debugging Mode: 0-off,1-off

extern string     Time_Inputs                   = "===== Timing settings: =====";
extern int        MainTimeFrame                 =      -1;     // Time Frame in min(0-current,-1-each tick mode)
extern int        TimeFilterMode                =       0;     // 0-off,1-on
extern int        StartHour                     =       0;     // Start Hour of Trade Session 
extern int        StartMinute                   =       0;     // Start Minute of Trade Session 
extern int        EndHour                       =      23;     // End Hour of Trade Session
extern int        EndMinute                     =      30;     // End Hour of Trade Session
extern int        MonStartHour                  =       0;     // Monday Start Hour of Trade Session 
extern int        MonStartMinute                =       0;     // Monday Start Minute of Trade Session 
extern int        FriEndHour                    =      22;     // Friday End Hour of Trade Session
extern int        FriEndMinute                  =      30;     // Friday End Hour of Trade Session
extern int        TradeDay                      =      -1;     // Trade Day of Week (ex.1-Monday,-1-all Days)
extern int        NonTradeDay                   =       0;     // Non-Trading Day of Week (ex.5-Friday)
extern int        CloseTimeMode                 =       0;     // CloseTime mode: 0-off,1-on
extern int        CloseHour                     =      24;     // Trade Close Hour   
extern int        CloseMinute                   =       0;     // Trade Close Minute   
extern int        FriCloseHour                  =      22;     // Trade Close Hour in Friday   
extern int        FriCloseMinute                =      55;     // Trade Close Minute in Friday 


extern string     macdInputs                    = "===== MACD Bars settings:=====";
extern int        macdTimeFrame                 =       0;     // TimeFrame in min
extern int        macdPrice                     =       0;     // Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int        macdFastEma                   =      12;
extern int        macdSlowEma                   =      26;
extern int        macdSignalEma                 =       9;
extern int        macdShift                     =       1;     // Shift in bars (0-current bar,1-previous)
extern int        macdMode                      =       1;     // MACD Mode: 0-off
extern int        tradesPerDirectionMACDBars    =       1;     // Number of allow trades per direction marked by MACDBars(0-off)
extern int        addTradesOnSameDirection      =       1;     // Additional trades on same direction if the previous was negative(0-off)

extern string     juiceInputs                   = "===== Juice settings: =====";
extern int        juiceTimeFrame                =       0;     // TimeFrame2 in min
extern int        juicePrice                    =       0;     // Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close)
extern int        juiceEMAPeriod                =       7;
extern int        juiceNormPeriod               =      80;
extern int        juiceShift                    =       1;     // 0-current bar,1-previous closed bar 
extern int        juiceMode1                    =       1;     // 1st Condition Juice Mode: 0-off
extern int        juiceMode2                    =       1;     // 2nd Condition Juice Mode: 0-off

extern string     mmInputs                      = "===== Money Management settings: =====";

extern double     Lots                          =    0.01;     // Lot size

extern string     balanceForEA                  = "===== Balance For EA =====";
extern bool       UseBalanceForEA               =   false;     //With this param, define if use total amount of balance of just a part of it (defined with BFE)
extern string     BFE_1                         = "Takes a % of the account balance(BFE%Account)";
extern double     BFEPct                        =      25;     //Quantity in % of the balance of the account that the EA will use to money managment:

//MoneyManagement settings
extern string     MoneyManagement               = "Money Management";
extern int        MM                            =       0;     //Uses this boolean to define if false: no uses MM, use the parameter Lots (on the next section)
extern string     MM_0                          = "mm=1, risk is basic multiplier based on account balance";
extern string     MM_1                          = "mm=2, risk is % of account balance to risk per sequence";

extern double     RiskFactor                    =       5;     // MM=1:  
extern double     RiskAB                        =      15;     // MM=2: How % on balance account risk to calculate per lot, mm=2.

extern string     MM_Martingale                 = "Martingale";
extern bool       Martingale                    =   false;
extern double     LotsMultiplier                =     2.0;     // Factor multiplication of lot per each lost operation.



//---------

double   ProcessTime = 3;
  
int      dRatio, error, pEntry, shots = 0, macdcom, juicecom, sigcom, trend[2], sells, buys, pBars;
bool     firstTime = true;
double   contract, lot_min, lot_step, lot_max, tick_val, _Point, minstop,
         upjuice[3],dnjuice[3], upbars[2], dnbars[2];
datetime pTime, pmTime, prevmacdTime, prevjuiceTime, prevsigTime, prevbarstime;
string   sComment;  
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
       
   dRatio   = MathPow(10,Digits%2);  
   lot_step = MarketInfo(Symbol(),MODE_LOTSTEP); 
   lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   contract = MarketInfo(Symbol(),MODE_LOTSIZE);   
   tick_val = MarketInfo(Symbol(),MODE_TICKVALUE)*dRatio;
   minstop  = MarketInfo(Symbol(),MODE_STOPLEVEL)/dRatio;
   _Point   = Point*dRatio;
   
   
   if(minstop == 0) minstop = 20/dRatio; 
   
   Print("contract=",DoubleToStr(contract,Digits));
   Print("tick_val=",DoubleToStr(tick_val,Digits));
   Print("minstop=" ,DoubleToStr(minstop,Digits));
   
   if(IsTesting() || IsVisualMode()) NumberOfTry = 1;
   if((IsTesting() && !IsVisualMode()) || IsOptimization()) CommentMode = 0;
   
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//---- 
   Comment("");
//----
   return(0);
}

//----
bool TimeCondition()
{
   bool result = false;
   
   if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
   {
      if(StartHour == 24) StartHour = 0; 
      
      datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
      double Start = StartHour + StartMinute/60.0;
      datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
      double End   = EndHour + EndMinute/60.0; 
   
      if(DayOfWeek() != 1 && DayOfWeek() != 5)
      {    
         if (Start < End) result = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);      
         else
         if (Start > End)
         result = (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59))
                ||(TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd);
      }
      else
      if(DayOfWeek() == 1)
      {    
      if(MonStartHour < 0 || MonStartMinute < 0) {MonStartHour = StartHour; MonStartMinute = StartMinute;}
         
         if(MonStartHour > 0 || MonStartMinute > 0) 
         {
         datetime MonSessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
         double MonStart = MonStartHour + MonStartMinute/60.0;
         }
         else
         {
         MonSessionStart = StrToTime(0+":"+0); //SessionStart;
         MonStart = 0;//Start;
         }
            
         if (Start < End)
         { 
            if (MonStart != 0) result = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
            else result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;
         }
         else
         if (Start > End)
         {
         result = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd) 
                  ||(TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59));
         }
      }
      else
      if(DayOfWeek() == 5)
      {
      if(FriEndHour < 0 || FriEndMinute < 0) {FriEndHour = EndHour; FriEndMinute = EndMinute;}   
         if(FriEndHour > 0 || FriEndMinute > 0)
         {
         datetime FriSessionEnd   = StrToTime(FriEndHour+":"+FriEndMinute);
         double FriEnd   = FriEndHour + FriEndMinute/60.0; 
         }
         else
         {
         FriSessionEnd   = SessionEnd;
         FriEnd = End; 
         }
            
         if (Start < End)
         {
         if (FriEnd != End) result = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
         else
         result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;  
         }
         else
         if (Start > End)
         result = (TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd)
                ||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
      }  
   }
   return(result);
}   


// ---- Money Management
double MoneyManagement (int mode,double maxloss,double profit,double plots)
{
   if(UseBalanceForEA && BFEPct > 0) double balance = AccountBalance()*BFEPct*0.01; else balance = AccountBalance();
   
   
   if(mode == 1 && RiskFactor > 0) double Lotsi = NormalizeDouble(balance*0.01*RiskFactor*AccountLeverage()/contract,2);  
   else
   if(mode == 2 &&  maxloss > 0) Lotsi = NormalizeDouble(maxloss*AccountLeverage()/contract,2);   
   else
   Lotsi = Lots;
      
   
 
   if(Martingale)
   {
   if(profit < 0) Lotsi = plots*LotsMultiplier; 
   }
   
   Lotsi = NormalizeDouble(Lotsi/lot_step,0)*lot_step;
      
   if(lot_max > 0 && Lotsi > lot_max) Lotsi = lot_max;  
   if(Lotsi < lot_min) Lotsi = lot_min;
   
   return(Lotsi);
}   


// ---- Open Sell Orders
void SellOrdOpen(int mode,double profit,double plots)
{		     
   double SellPrice, SellStop, SellProfit, Stop, Profit;
   int ticket = 0, tr = 1, ord = mode;
   
   
   while (ticket <= 0 && tr <= NumberOfTry)
   {     
      while(!IsTradeAllowed()) Sleep(5000); RefreshRates();      
      
      double _Ask = Ask;//MarketInfo(Symbol(),MODE_ASK);
      double _Bid = Bid;////MarketInfo(Symbol(),MODE_BID);
      
      if(mode == OP_SELL     ) SellPrice = _Bid;
      else 
      if(mode == OP_SELLLIMIT) SellPrice = MathMax(High[0],High[1]) + OrderDistance *_Point; 
      else
      if(mode == OP_SELLSTOP ) SellPrice = MathMin(Low[0] , Low[1]) - OrderDistance *_Point; 
           	  
   if(StopLossSELL > 0) SellStop = SellPrice + StopLossSELL*_Point; else SellStop = 0;
    
         
   if(SellStop > 0 && SellStop - _Ask < minstop*_Point) SellStop = NormalizeDouble(_Ask + minstop*_Point,Digits);       
         
   if(TakeProfitSELL > 0) SellProfit = SellPrice  - TakeProfitSELL*_Point; else SellProfit = 0;
      
   if(SellProfit > 0 && _Bid - SellProfit < minstop*_Point) SellProfit = NormalizeDouble(_Bid - minstop*_Point,Digits);    
      
   if(MM == 2 && BFEPct > 0 && RiskAB > 0) double maxloss = AccountBalance()*BFEPct*RiskAB*0.0001;///_Point;//(SellStop - SellPrice)*tick_val/_Point; 
   
   double lots = MoneyManagement(MM, maxloss, profit, plots);
    
       
   if(EcnBroker && mode == 1) {Stop = 0; Profit = 0;} else {Stop = SellStop; Profit = SellProfit;} 

   ticket = OrderSend(Symbol(),mode,lots,
	                   NormalizeDouble(SellPrice, Digits),
	                   MaxSlippage*dRatio,
	                   NormalizeDouble(     Stop, Digits),
	                   NormalizeDouble(   Profit, Digits),
	                   CustomComment+" SELL",Magic,0,Red);
   
      if(ticket > 0) 
      {
      sells++;
      }
      else
      if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
         if(GetLastError() > 0)
         {      
         Print("SELL : OrderSend failed with error #",ErrorDescription(GetLastError()));
         if(DebugMode > 0) Print("open=",DoubleToStr(Open[1],Digits)," price=",DoubleToStr(SellPrice,Digits)," sl=",DoubleToStr(Stop,Digits)," tp=",DoubleToStr(Profit,Digits)); 
         }
      }    	
   }         
}
// ---- Open Buy Orders
void BuyOrdOpen(int mode,double profit,double plots)
{		     
   double BuyPrice, BuyStop, BuyProfit, Stop, Profit;
   int ticket = 0, tr = 1, ord = mode;
   
   while(ticket <= 0 && tr <= NumberOfTry)
   {        
      while(!IsTradeAllowed()) Sleep(5000); RefreshRates();  
      
      double _Ask = Ask; //MarketInfo(Symbol(),MODE_ASK);
      double _Bid = Bid; //MarketInfo(Symbol(),MODE_BID);
      
      if(mode == OP_BUY     ) BuyPrice = _Ask;
      else
      if(mode == OP_BUYLIMIT) BuyPrice = MathMin(Low[0] ,Low[1] ) - OrderDistance *_Point;
      else
      if(mode == OP_BUYSTOP ) BuyPrice = MathMax(High[0],High[1]) + OrderDistance *_Point;
      
   if(StopLossBUY > 0) BuyStop = BuyPrice - StopLossBUY*_Point; else	BuyStop = 0;
   
   if(BuyStop > 0 && _Bid - BuyStop < minstop*_Point) BuyStop = NormalizeDouble(_Bid - minstop*_Point,Digits); 
      
   if(TakeProfitBUY > 0) BuyProfit = BuyPrice + TakeProfitBUY*_Point; else BuyProfit = 0; 
   
   if(BuyProfit > 0 && BuyProfit - _Ask < minstop*_Point) BuyProfit = NormalizeDouble(_Ask + minstop*_Point,Digits);     
         
   if(MM == 2 && BFEPct > 0 && RiskAB > 0) double maxloss = AccountBalance()*BFEPct*RiskAB*0.0001;//_Point;//(SellStop - SellPrice)*tick_val/_Point; 
   
   double lots = MoneyManagement(MM, maxloss, profit, plots);
  
   if(EcnBroker && mode == 0) {Stop = 0; Profit = 0;} else {Stop = BuyStop; Profit = BuyProfit;}     
      
   ticket = OrderSend(Symbol(),mode,lots,
                      NormalizeDouble(BuyPrice,Digits),
	                   MaxSlippage*dRatio,
	                   NormalizeDouble(    Stop,Digits), 
	                   NormalizeDouble(  Profit,Digits),
	                   CustomComment+" BUY",Magic,0,Blue);
      
      if(ticket > 0) 
      {
      buys++;
      }
	   else
	   if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError() > 0)      
      Print("BUY : OrderSend failed with error #",ErrorDescription(GetLastError()));
      } 	    
   }
} 


// ---- Scan Trades
int ScanTrades(int magic,int& buy,int& sell,int& buylimit,int& selllimit,int& buystop,int& sellstop)
{   
   buy = 0; sell = 0; buylimit = 0; selllimit = 0; buystop = 0; sellstop = 0;
     
   for(int cnt=0; cnt <OrdersTotal(); cnt++) 
   {        
   if(!OrderSelect(cnt, SELECT_BY_POS)) continue;            
   if(OrderSymbol() != Symbol() || (magic > 0 && OrderMagicNumber() != magic)) continue;  
      
      if(OrderType() == OP_BUY ) buy++;
      if(OrderType() == OP_SELL) sell++;         
      if(OrderType() == OP_BUYLIMIT ) buylimit++;
      if(OrderType() == OP_SELLLIMIT) selllimit++;
      if(OrderType() == OP_BUYSTOP ) buystop++;
      if(OrderType() == OP_SELLSTOP) sellstop++;        
      
   }
   
   return(buy+sell+buylimit+selllimit+buystop+sellstop);
}  


void ChartComment()
{
   int buy, sell, buylimit, selllimit, buystop, sellstop;
   
   
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   double pips = TotalProfit(0,2,0,0);
   double usd  = TotalProfit(0,3,0,0);
      
   if(ShowDailyProfit > 0)
   {
   double hist = TotalProfit(0,3,1,StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)));
   double sum  = hist + usd;     
   }
   
   int total = ScanTrades(Magic,buy,sell,buylimit,selllimit,buystop,sellstop);
   sComment = "";   
   sComment = sp;
   sComment = sComment+"Expert Name : "+ExpertName+NL;
   sComment = sComment+sp;
   sComment = sComment+"Time: Current= "+TimeToStr(TimeCurrent()) + NL;
   sComment = sComment+"Orders: Open= "+(buy+sell)+" Pending= "+(buylimit+selllimit+buystop+sellstop)+" All= "+total+NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToStr(pips,1) + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToStr(usd ,2) + NL;
   if(ShowDailyProfit > 0) sComment = sComment+"Daily Profit(USD): Closed= " + DoubleToStr(hist,2) + " Open= " + DoubleToStr(usd,2) + " Summary = " + DoubleToStr(sum,2) + NL; 
   
   sComment = sComment+sp;
   
   if(DebugMode > 0) 
   {
   sComment = sComment+"upmacd[0] = " + DoubleToStr(upbars[0] ,     0) + " dnmacd[0] = " + DoubleToStr(dnbars[0] ,     0) + NL; 
   sComment = sComment+"upmacd[1] = " + DoubleToStr(upbars[1] ,     0) + " dnmacd[1] = " + DoubleToStr(dnbars[1] ,     0) + NL; 
   sComment = sComment+"upjuice[0]= " + DoubleToStr(upjuice[0],Digits) + " dnjuice[0]= " + DoubleToStr(dnjuice[0],Digits) + NL; 
   sComment = sComment+"upjuice[1]= " + DoubleToStr(upjuice[1],Digits) + " dnjuice[1]= " + DoubleToStr(dnjuice[1],Digits) + NL; 
   
   sComment = sComment+sp;
   sComment = sComment+"macd   = "  + macdcom  + " macdTime  =" + TimeToStr( prevmacdTime,TIME_DATE|TIME_SECONDS) + NL;
   sComment = sComment+"juice  = "  + juicecom + " juiceTime =" + TimeToStr(prevjuiceTime,TIME_DATE|TIME_SECONDS) + NL;
   sComment = sComment+"signal = "  + sigcom   + " sigTime   =" + TimeToStr(prevsigTime  ,TIME_DATE|TIME_SECONDS) + NL;
   }
   
   Comment(sComment);
}

double TotalProfit(int trade,int pmode,int hmode,datetime date)
{
   double Pips = 0, profit=0, totalPips = 0, totalProfits = 0, mPips = 0;   
      
      if(hmode == 0) 
      {
      int total = OrdersTotal(); 
      int opt   = MODE_TRADES;
      }
      else 
      {
      total = OrdersHistoryTotal();
      opt   = MODE_HISTORY;
      }
      
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS, opt);   
   
   int  mode = OrderType();
   bool mcondition = false, dcondition = false;
   
   if(Magic > 0 && OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) mcondition = true;
   else if(Magic == 0) mcondition = true;   
   
   if(date > 0)
   { 
   if(date == StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE))) dcondition = true;
   }
   else
   if(date == 0) dcondition = true;  
       
      if(mcondition && dcondition)
      {      
         if(mode == OP_BUY && (trade == 1 || trade == 0))
         {
         Pips   = (OrderClosePrice() - OrderOpenPrice())/_Point;
         profit = OrderProfit() + OrderSwap() + OrderCommission();
         totalPips    += Pips;
         totalProfits += profit;
         }
         
         if (mode == OP_SELL && (trade == 2 || trade == 0))   
         {          
         Pips   = (OrderOpenPrice() - OrderClosePrice())/_Point;
         profit = OrderProfit() + OrderSwap() + OrderCommission();
         totalPips    += Pips;
         totalProfits += profit;
         }
      }            
	}
   if(pmode == 0) return(Pips);
   else
   if(pmode == 1) return(profit);
   else
   if(pmode == 2) return(totalPips);
   else
   if(pmode == 3) return(totalProfits);
   
}


int MACDbars(int mode,int tf,int p,int fast,int slow,int signal,int bar)
{   
   string indName = "MACD Bars";
   
   upbars[0] = iCustom(NULL,tf,indName,fast,slow,signal,p,0,bar);
   upbars[1] = iCustom(NULL,tf,indName,fast,slow,signal,p,0,bar+1);
      
   dnbars[0] = iCustom(NULL,tf,indName,fast,slow,signal,p,1,bar);
   dnbars[1] = iCustom(NULL,tf,indName,fast,slow,signal,p,1,bar+1);
   
   if(prevbarstime != iTime(NULL,tf,bar)) {trend[1] = trend[0]; prevbarstime = iTime(NULL,tf,bar);}  
   
   trend[0] = trend[1];
   
   if(upbars[0] == 1 && trend[1] <= 0) {trend[0] = 1; buys  = 0;}
   if(dnbars[0] == 1 && trend[1] >= 0) {trend[0] =-1; sells = 0;}
   
      
   switch(mode)
   {
   case 1:  if(upbars[0] == 1 && dnbars[0] == EMPTY_VALUE) return( mode); 
            if(dnbars[0] == 1 && upbars[0] == EMPTY_VALUE) return(-mode);  
            break; 
   
   case 2:  if(upbars[0] == 1 && dnbars[1] == 1) return( mode); 
            if(dnbars[0] == 1 && upbars[1] == 1) return(-mode); 
            break; 
   }
         
   return(0);  
}

int Juice(int mode1,int mode2,int tf,int p,int len,int norm,int bar)
{   
   string indName = "directional normalized juice";
   
   
   upjuice[0] = iCustom(NULL,tf,indName,p,len,norm,0,bar);   
   upjuice[1] = iCustom(NULL,tf,indName,p,len,norm,0,bar+1);
   upjuice[2] = iCustom(NULL,tf,indName,p,len,norm,0,bar+2);
   
   dnjuice[0] = iCustom(NULL,tf,indName,p,len,norm,1,bar);   
   dnjuice[1] = iCustom(NULL,tf,indName,p,len,norm,1,bar+1);
   dnjuice[2] = iCustom(NULL,tf,indName,p,len,norm,1,bar+2);   
   
   for(int i=0;i<3;i++) 
   {
   if(upjuice[i] == EMPTY_VALUE) upjuice[i] = 0;
   if(dnjuice[i] == EMPTY_VALUE) dnjuice[i] = 0;
   }
        
   if((mode1 == 1 && upjuice[0] > 0 && dnjuice[1] < 0)
   || (mode2 == 1 && upjuice[0] > 0 && upjuice[1] > 0 && upjuice[2] > 0 && upjuice[1] < upjuice[2] && upjuice[0] > upjuice[1])) return( MathMax(mode1,mode2)); 
   
   if((mode1 == 1 && dnjuice[0] < 0 && upjuice[1] > 0)
   || (mode2 == 1 && dnjuice[0] < 0 && dnjuice[1] < 0 && dnjuice[2] < 0 && dnjuice[1] > dnjuice[2] && dnjuice[0] < dnjuice[1])) return(-MathMax(mode1,mode2)); 
     
    
   return(0);  
}




int TradeSignal()
{   
   int signal = 0, macd = 0, f_macd = 0, juice = 0; 
   
   
   if(firstTime) f_macd  = MACDbars(2,macdTimeFrame,macdPrice,macdFastEma,macdSlowEma,macdSignalEma,macdShift);
   
   if(f_macd != 0) firstTime = false;
    
   if(macdMode   > 0) macd  = MACDbars(macdMode,macdTimeFrame,macdPrice,macdFastEma,macdSlowEma,macdSignalEma,macdShift);
   
   if(juiceMode1 > 0 
   || juiceMode2 > 0) juice = Juice(juiceMode1,juiceMode2,juiceTimeFrame,juicePrice,juiceEMAPeriod,juiceNormPeriod,juiceShift);
   
   
     
   if(macd != 0 && TimeCurrent() != prevmacdTime) 
   {
   macdcom = macd;
   prevmacdTime = TimeCurrent();
   }
   
   if(juice != 0 && TimeCurrent() != prevjuiceTime)
   { 
   juicecom = juice;
   prevjuiceTime = TimeCurrent();
   }
   
   if(!firstTime && (macd != 0 || juice != 0))
   {
   if(macd == macdMode && juice == MathMax(juiceMode1,juiceMode2)) signal = 1; 
   if(macd ==-macdMode && juice ==-MathMax(juiceMode1,juiceMode2)) signal =-1;  
   }
   
   if(signal != 0 && TimeCurrent() != prevsigTime)
   { 
   sigcom = signal;
   prevsigTime = TimeCurrent();
   }
   
   return(signal);
}

bool CloseOrder(int mode)  
{
   bool result = false; 
   int  total  = OrdersTotal();
   
   for (int cnt=0; cnt < OrdersTotal(); cnt++)  
   {
   if(!OrderSelect(cnt, SELECT_BY_POS)) continue;   
   if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic) continue; 
   
   if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result = CloseAtMarket(1,OrderTicket(),OrderLots(),Aqua);
   if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result = CloseAtMarket(2,OrderTicket(),OrderLots(),Pink);
   }
   return(result);
}


bool CloseAtMarket(int mode,int ticket,double lot,color clr) 
{
   bool   result = false; 
   double price; 
         
   int tries=0;
   while (!result && tries < NumberOfTry) 
   {
      RefreshRates();
      
      if(mode == 1) price = NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),Digits);
      if(mode == 2) price = NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),Digits);
      
      result = OrderClose(ticket,lot,price,dRatio*MaxSlippage,clr);
      
      if (!result) 
      {
      Print("Error closing order : ",ErrorDescription(GetLastError())," ticket=",ticket," lot=",lot," Price=",price);
      Sleep(5000);
      }
      
      tries++;
   }
         
   return(result);
}

bool isNewBar(int tf)
{
   static datetime pTime;
   bool res=false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0)!= pTime)
      {
      res=true;
      pTime=iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}



void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain, BuyStop, SellStop, price;
   int    total = OrdersTotal(); 
   
   
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);   
   int mode=OrderType();    
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if(mode == OP_BUY) 
         {
			Gain = 0; BuyStop = 0;
			   
			   if(BreakEvenBUY > 0 && NormalizeDouble(OrderStopLoss()-OrderOpenPrice(),Digits) < NormalizeDouble(ProfitLockBUY*_Point,Digits))// && buyBEvent < total )
			   {
			   price = MarketInfo(Symbol(),MODE_BID); 
			   
			   Gain = NormalizeDouble((price - OrderOpenPrice())/_Point,Digits);
			   if(Gain >= BreakEvenBUY) BuyStop = NormalizeDouble(OrderOpenPrice()+ProfitLockBUY*_Point,Digits);
			   }
			   else
			   if(TrailingStopBUY > 0) 
			   {
			   BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStopBUY*_Point,Digits);
			   
			      if(BuyStop >= NormalizeDouble(OrderStopLoss() + TrailStopStepBUY*_Point,Digits)) BuyStop = NormalizeDouble(BuyStop,Digits); 
			      else BuyStop = NormalizeDouble(OrderStopLoss(),Digits);
			   }
			   else BuyStop = 0; 			   
			   //Print("BuyStop=",BuyStop);     
			   if(BuyStop <= 0) continue; 
			   
			   double _Bid = MarketInfo(Symbol(),MODE_BID);
			   if (_Bid - BuyStop < minstop*_Point) BuyStop = NormalizeDouble(_Bid - minstop*_Point,Digits);   
              
			   if(NormalizeDouble(OrderOpenPrice(),Digits) <= BuyStop) 
            {   
			      if(BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			      //Print("BS=",BuyStop);   
			         for(int k = 0 ; k < NumberOfTry; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              NormalizeDouble(BuyStop,Digits),
			                              NormalizeDouble(OrderTakeProfit(),Digits),
			                              0,Lime);
                  error=GetLastError();
                     if(error == 0 && result) break;
                     else 
                     {
                     Print("BUY Trail: OOP=",DoubleToStr(OrderOpenPrice(),Digits)," BS=",DoubleToStr(BuyStop,Digits)," bid=",DoubleToStr(Bid,Digits));
                     Sleep(5000); 
                     RefreshRates(); 
                     continue;
                     }
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode == OP_SELL)
         {
         Gain = 0; SellStop = 0;
            
            if (BreakEvenSELL > 0 && (NormalizeDouble(OrderOpenPrice()-OrderStopLoss(),Digits) < NormalizeDouble(ProfitLockSELL*_Point,Digits) || OrderStopLoss()== 0))// && sellBEvent > -total)
			   {
			   price = MarketInfo(Symbol(),MODE_ASK);
			   Gain = NormalizeDouble((OrderOpenPrice()-price)/_Point,Digits);
			   if( Gain >= BreakEvenSELL) SellStop = NormalizeDouble(OrderOpenPrice()-ProfitLockSELL*_Point,Digits);
			   }
			   else
			   if(TrailingStopSELL > 0) 
			   {
			   SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) + TrailingStopSELL*_Point,Digits);
			      if(SellStop <= NormalizeDouble(OrderStopLoss() - TrailStopStepSELL*_Point,Digits)) SellStop = NormalizeDouble(SellStop,Digits); 
			      else SellStop = NormalizeDouble(OrderStopLoss(),Digits);
            }
			   else SellStop = 0;
			   //Print("SellStop=",SellStop);                       
            if(SellStop <= 0) continue;
            
            double _Ask = MarketInfo(Symbol(),MODE_ASK);
            if (SellStop - _Ask < minstop*_Point) SellStop = NormalizeDouble(_Ask + minstop*_Point,Digits);   
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop > 0) 
            {
               if(SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < NumberOfTry; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              NormalizeDouble(SellStop,Digits),
			                              NormalizeDouble(OrderTakeProfit(),Digits),
			                              0,Orange);
                  error  = GetLastError();
                     if(error==0 && result) break;
                     else 
                     {
                     Print("Sell Trail: OOP=",DoubleToStr(OrderOpenPrice(),Digits)," SS=",DoubleToStr(SellStop,Digits)," Ask =", DoubleToStr(Ask,Digits));
                     Sleep(5000); 
                     RefreshRates(); 
                     continue;
                     }
                  }
               }   
   			}	    
         }
      }
   }     
}

void ECN_Init(int trades)
{
   int    error, np, shift;  
   bool   result=false;
   double BuyStop=0, SellStop=0;
   double BuyProfit=0, SellProfit=0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode = OrderType();    
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && (OrderStopLoss() == 0 || OrderTakeProfit() == 0)) 
      {
         if (mode == OP_BUY ) 
         {
            if(OrderStopLoss() == 0 && StopLossBUY > 0) 
		      {
            BuyStop  = OrderOpenPrice() - StopLossBUY*_Point; 
            if(OrderOpenPrice() - NormalizeDouble(BuyStop,Digits) < minstop*_Point) BuyStop = OrderOpenPrice() - minstop *_Point;
            }   
			   else BuyStop = OrderStopLoss();
			   			   
			   if(OrderTakeProfit() == 0 && TakeProfitBUY > 0)  
		      {
		      BuyProfit = OrderOpenPrice() + TakeProfitBUY*_Point; 
			   if(NormalizeDouble(BuyProfit,Digits) - OrderOpenPrice() < minstop*_Point) BuyProfit = OrderOpenPrice() + minstop*_Point;
			   }  
			   else BuyProfit = OrderTakeProfit();
			    
			   if(DebugMode > 0) Print("BuyStop=",BuyStop," BuyProfit=",BuyProfit);
			   
			   for(int k = 0 ; k < NumberOfTry; k++)
            {
            result = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),Digits),
			                        NormalizeDouble(BuyStop,Digits),
			                        NormalizeDouble(BuyProfit,Digits),0,Lime);
            error = GetLastError();
               if(error==0) break;
               else {Sleep(5000); RefreshRates(); continue;}
            }   		 
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if(OrderStopLoss() == 0 && StopLossSELL > 0)  
		      {
            SellStop  = OrderOpenPrice() + StopLossSELL*_Point; 
            if(NormalizeDouble(SellStop,Digits) - OrderOpenPrice() < minstop *_Point) SellStop = OrderOpenPrice() + minstop *_Point;
			   }   
			   else SellStop = OrderStopLoss();
            
            if(OrderTakeProfit() == 0 && TakeProfitSELL > 0)   
		      {
		      SellProfit = OrderOpenPrice() - TakeProfitSELL*_Point; 
			   if(OrderOpenPrice() - NormalizeDouble(SellProfit,Digits) < minstop*_Point) SellProfit = OrderOpenPrice() - minstop*_Point;
			   }  
			   else SellProfit = OrderTakeProfit();
                       
            if(DebugMode > 0) Print("SellStop=",SellStop," SellProfit=",SellProfit);
            
            for( k = 0 ; k < NumberOfTry; k++)
            {
            result = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),Digits),
			                        NormalizeDouble(SellStop,Digits),
			                        NormalizeDouble(SellProfit,Digits),0,Orange);
            error=GetLastError();
               if(error==0) break;
               else {Sleep(5000); RefreshRates(); continue;}
            }	    
         }
      }
   }     
}

void TradeControl(int buy,int sell,int buylimit,int selllimit,int buystop,int sellstop, int signal)
{
   int open    = buy + sell;
   int pending = buylimit+buystop+selllimit+sellstop;
   int trades  = open + pending;
      
   if(pending > 0)
   {
      if(signal != 0) 
      {
      if(signal > 0 && selllimit + sellstop > 0) PendOrdDel(2);
      if(signal < 0 && buylimit  + buystop  > 0) PendOrdDel(1); 
      }
          
      if(open > 0) 
      {
      if(sell > 0 && selllimit + sellstop > 0) PendOrdDel(2);
      if(buy  > 0 && buylimit  + buystop  > 0) PendOrdDel(1); 
      }
   
   if(PendingOrderExp > 0) DeleteByExpiration(PendingOrderExp);
   }
      
   if(EcnBroker && (StopLossBUY > 0 || StopLossSELL > 0)||(TakeProfitBUY > 0 || TakeProfitBUY > 0)) ECN_Init(trades);
   if((BreakEvenBUY > 0 || BreakEvenSELL > 0) || (TrailingStopBUY > 0 || TrailingStopSELL > 0)) TrailStop();   
 
  
   double buypips  = TotalProfit(1,0,0,0);   
   double sellpips = TotalProfit(2,0,0,0); 
   
   if(buy  > 0 && (HideTakeProfit > 0 && buypips  >= TakeProfitBUY )||(HideStopLoss > 0 && buypips  <=-StopLossBUY )) CloseAtMarket(1,OrderTicket(),OrderLots(),Aqua);
   if(sell > 0 && (HideTakeProfit > 0 && sellpips >= TakeProfitSELL)||(HideStopLoss > 0 && sellpips <=-StopLossSELL)) CloseAtMarket(2,OrderTicket(),OrderLots(),Pink);
   
   if(macdExitMode > 0)
   {
      if(macdExitMode == 1)
      {
      if(buy  > 0 && dnbars[0] == 1 && upbars[1] == 1 && buypips  > MinProfit) CloseOrder(1);
      if(sell > 0 && upbars[0] == 1 && dnbars[1] == 1 && sellpips > MinProfit) CloseOrder(2);      
      }
   }
    
   if(juiceExitMode > 0)
   {
      if(juiceExitMode == 1)
      {
      if(buy  > 0 && dnjuice[0] < 0 && upjuice[1] > 0 && upjuice[1] != EMPTY_VALUE && buypips  > MinProfit) CloseOrder(1);
      if(sell > 0 && upjuice[0] > 0 && dnjuice[1] < 0 && upjuice[0] != EMPTY_VALUE && sellpips > MinProfit) CloseOrder(2);      
      }
   }  
     
      
   if (CloseTimeMode > 0) 
   {
   if(CloseHour >= 0) datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
   if(FriCloseHour >= 0 && DayOfWeek() == 5 && FriCloseHour > StartHour) TimeClose = StrToTime(FriCloseHour+":"+FriCloseMinute); 
      
   if(TimeCurrent() >= TimeClose && TimeCurrent() < TimeClose+ProcessTime*60) CloseOrder(0); 
   }
}

// Closing of Pending Orders      
void PendOrdDel(int mode)
{
   bool result = false;
   
   for (int i=0; i<OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)     
      {
         if((mode==0 || mode==1) && (OrderType() == OP_BUYSTOP || OrderType() == OP_BUYLIMIT))
         {     
         result = OrderDelete(OrderTicket());
         if(!result) Print("BUY: OrderDelete failed with error #",GetLastError());
         }
         else
         if((mode==0 || mode==2) && (OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT))
         {     
         result = OrderDelete( OrderTicket() );  
         if(!result) Print("SELL: OrderDelete failed with error #",GetLastError());
         }
      }
   }
}

void DeleteByExpiration(int exp)
{
   bool result = false;
   
   for(int i=0;i<OrdersTotal();i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)     
      {
         if(OrderType() > OP_SELL)
         {     
            if(iBarShift(Symbol(),NULL,OrderOpenTime()) - iBarShift(Symbol(),NULL,TimeCurrent()) >= exp)
            {
            result = OrderDelete(OrderTicket());
            if(!result) Print("Expiration: OrderDelete failed with error #",GetLastError());
            }
         }
      }
   }
}

double PastTradeProfit(int ord,datetime& ptime,double& plots)
{
   double pips; 
   int total = OrdersHistoryTotal();
      
   for(int cnt=total-1;cnt>=0;cnt--) 
   {
   if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic) continue;     
   if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY) && OrderType() > OP_SELL ) continue;
         
      if((ord == 0 || ord == 1) && OrderType() == OP_BUY ) 
      {
      pips  = (OrderClosePrice() - OrderOpenPrice())/_Point; 
      ptime = OrderOpenTime();
      plots = OrderLots();
      break;
      }
      if((ord == 0 || ord == 2) && OrderType() == OP_SELL) 
      {
      pips  = (OrderOpenPrice() - OrderClosePrice())/_Point; 
      ptime = OrderOpenTime();
      plots = OrderLots();
      break;
      }
   }
   
   return(pips);   
} 

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int trades, buy, sell, buylimit, selllimit, buystop, sellstop, bmode, smode;
   
   if(iBars(Symbol(),0) < 100) {Print("Bars=",iBars(Symbol(),0)," < 100!"); return(0);}
   if(GetLastError() == 134)   {Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0);}
   if(DebugMode > 0 && !IsTradeAllowed())    Print("Trade is not allowed!");
   if(DebugMode > 0 && IsTradeContextBusy()) Print("Trade context is busy. Please wait"); 
   
//---- 
   if(TimeFilterMode > 0) bool timecond = TimeCondition(); else timecond = true;
 
   trades  = ScanTrades(Magic,buy,sell,buylimit,selllimit,buystop,sellstop);
   
   if(trades == 0 && !timecond) return(0); 
      
   if(isNewBar(MainTimeFrame)) int Signal = TradeSignal(); //else return(0);
   
      
   if(CommentMode > 0) ChartComment();
     
   
   if(trades > 0) TradeControl(buy, sell, buylimit, selllimit, buystop, sellstop, Signal);
    
   if(SpreadProtection) bool spreadfilter = (Ask - Bid)/_Point <= MaxSpreadPermitted; else spreadfilter = true;
   
   trades = ScanTrades(Magic,buy,sell,buylimit,selllimit,buystop,sellstop);
     
   if(AllowOnlyOneActiveTrade)
   {
   int alltrades = ScanTrades(0,buy,sell,buylimit,selllimit,buystop,sellstop);  
   if(alltrades == 1) {Comment(sComment +"\n\nWARNING!!! Can\'t be more than one trade on the same pair!"); return(0);} 
   }
   
   if(tradesPerDirectionMACDBars > 0)
   {
   bool buytrade  = buys  < tradesPerDirectionMACDBars; 
   bool selltrade = sells < tradesPerDirectionMACDBars; 
   }
   else {buytrade  = true; selltrade = true;}
   
   double   pLots; 
   datetime prevTime;
   
   
   if(addTradesOnSameDirection > 0 || Martingale)
   {
   double pastProfit = PastTradeProfit(0,prevTime,pLots); 
      
      if(pastProfit < 0)
      {
      if(buys  > 0 && buys  < tradesPerDirectionMACDBars + addTradesOnSameDirection) buytrade  = true;
      if(sells > 0 && sells < tradesPerDirectionMACDBars + addTradesOnSameDirection) selltrade = true;
      }
   }
      
   if(Signal != 0 && trades < MaxOrders && timecond && spreadfilter && (buytrade || selltrade) && Bars != pBars)
   {
      if(OrderMode < 3)
      {
         switch(OrderMode)
         {
         case 0:  bmode = OP_BUY     ; smode = OP_SELL     ; break;
         case 1:  bmode = OP_BUYLIMIT; smode = OP_SELLLIMIT; break;
         case 2:  bmode = OP_BUYSTOP ; smode = OP_SELLSTOP ; break;
         }
         
         if(Signal > 0 && OnlyBuyMode  && buytrade ) BuyOrdOpen (bmode,pastProfit,pLots);
         if(Signal < 0 && OnlySellMode && selltrade) SellOrdOpen(smode,pastProfit,pLots);
      }
      else 
      if(OrderMode == 3)
      {
      if(Signal > 0 && OnlyBuyMode  && buytrade ) {BuyOrdOpen (OP_BUYLIMIT ,pastProfit,pLots); BuyOrdOpen (OP_BUYSTOP ,pastProfit,pLots);}
      if(Signal < 0 && OnlySellMode && selltrade) {SellOrdOpen(OP_SELLLIMIT,pastProfit,pLots); SellOrdOpen(OP_SELLSTOP,pastProfit,pLots);}  
      }        
        
   if(!AllowMultipleTradesOnBar) pBars = Bars; else pBars = 0;
   }
   
   
   
 return(0);
}//int start
//+------------------------------------------------------------------+






